'*
'* Citac
'*

                ' adresa LPT
1 : DEF SEG = &H40: Lpt = PEEK(&H8) + PEEK(&H8 + 1) * 256

                ' hodnoty casove zakladny
    DIM TimeBs(0 TO 7) AS LONG
    FOR x = 0 TO 7: READ TimeBs(x): NEXT x
    DATA 32768,2048,1024,256,128,32,8,2

2 : CONST PocCit = 1            ' pocet citacu - 1
    TS = 7                      ' zvoleny rozsah casove zakladny
    Mode = 0                    ' mod: =0 -> citani; =1 -> perioda;
    MAX = 2 ^ ((PocCit + 1) * 8)
    CLS

Start:
    LOCATE 13, 5: PRINT "*"
    OUT Lpt, 1 + TS * 2 + Mode * 16             ' pocatecni stav
    OUT Lpt, INP(Lpt) OR 1 * 32                 ' reset
    OUT Lpt, INP(Lpt) AND (NOT 1 * 32)          ' konec resetu
    OUT Lpt, INP(Lpt) OR 1 * 64                 ' start
    LOCATE 13, 5: PRINT " "

    DO
        k$ = UCASE$(INKEY$)                     ' klavesnice...
        SELECT CASE k$
            CASE "P": Mode = 1: TS = 0
            CASE "C": Mode = 0: TS = 7
            CASE CHR$(27): SYSTEM
        END SELECT

        s = INT(INP(Lpt + 1) / 16) AND 3        ' status citace
        IF s <> 0 THEN
            LOCATE 9, 5
            IF Mode = 0 THEN PRINT "citani " ELSE PRINT "perioda"
            LOCATE 10, 5: PRINT "Casova zakladna = ", TimeBs(TS); "Hz     "
            IF (s AND 1) = 1 THEN GOSUB Preteceni ELSE GOSUB Zobraz
            GOTO Start
        END IF
    LOOP

Preteceni:
    LOCATE 13, 7: PRINT CHR$(24); "            "
    LOCATE 14, 7: PRINT "                "
    IF Mode = 0 THEN                            ' zmena rozsahu
        IF TS > 0 THEN TS = TS - 1
    ELSE
        IF TS < 7 THEN TS = TS + 1
    END IF
    RETURN

Zobraz:
    GOSUB CtiData
    IF Mode = 0 THEN Freq = h * TimeBs(TS) ELSE Freq = TimeBs(TS) / h
   
    LOCATE 13, 7: PRINT "Freq = "; Freq; "Hz           "
    LOCATE 14, 7: PRINT "Per = "; 1 / Freq; "s          "

    IF Mode = 0 THEN            ' automaticka uprava rozsahu
        IF TS < 7 THEN
            IF Freq / TimeBs(TS + 1) < MAX THEN TS = TS + 1
        END IF
    ELSE
        IF TS > 0 THEN
            IF TimeBs(TS - 1) / Freq < MAX THEN TS = TS - 1
        END IF
    END IF

    RETURN

CtiData:        ' podprogram, cte data z citace, vrati hodnotu v `h`
    OUT Lpt, 0: OUT Lpt, 1          ' presun do posuvneho registru
    h = 0
    FOR y = 0 TO PocCit
        FOR x = 0 TO 7
            hx = INT(INP(Lpt + 1) / 128) AND 1      ' signal na BUSY
            h = h * 2 + hx
            OUT Lpt, 1 + 1 * 32: OUT Lpt, 1         ' posun na dalsi
        NEXT x
    NEXT y
    RETURN

